function varargout = Inverse_reconstruction(varargin)
% License owner: Mozhdeh Seifi, Corinne Fournier, Loic Denis
%
% This work is licensed under a Creative Commons Attribution 
% Non-Commercial No Derivatives 3.0 France license. In essence, 
% you are free to copy and communicate the work in its current form
% for non-commercial purposes, as long as you attribute the authors
% and abide by the license terms.
% You may not alter or adapt the work in any way.
%
% To view a copy of this license, visit
% http://creativecommons.org/licenses/by-nc-nd/3.0/
%-------------------------------------------------------------------------%
% INVERSE_RECONSTRUCTION MATLAB code for Inverse_reconstruction.fig
%      INVERSE_RECONSTRUCTION, by itself, creates a new INVERSE_RECONSTRUCTION or raises the existing
%      singleton*.
%
%      H = INVERSE_RECONSTRUCTION returns the handle to a new INVERSE_RECONSTRUCTION or the handle to
%      the existing singleton*.
%
%      INVERSE_RECONSTRUCTION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in INVERSE_RECONSTRUCTION.M with the given input arguments.
%
%      INVERSE_RECONSTRUCTION('Property','Value',...) creates a new INVERSE_RECONSTRUCTION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Inverse_reconstruction_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Inverse_reconstruction_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Inverse_reconstruction

% Last Modified by GUIDE v2.5 22-Oct-2012 16:43:05

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Inverse_reconstruction_OpeningFcn, ...
                   'gui_OutputFcn',  @Inverse_reconstruction_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Inverse_reconstruction is made visible.
function Inverse_reconstruction_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Inverse_reconstruction (see VARARGIN)

% Choose default command line output for Inverse_reconstruction

handles.output = hObject;
guidata(hObject, handles);
imageArray =imread('logo_h.jpg');
axes(handles.axes1);
imshow(imageArray);
% Update handles structure
guidata(hObject, handles);

imageArray =imread('logo_univ.jpg');
axes(handles.axes3);
imshow(imageArray);
% Update handles structure
guidata(hObject, handles);

imageArray =imread('license.png');
axes(handles.axes2);
imshow(imageArray);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Inverse_reconstruction wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Inverse_reconstruction_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
% save flag_frames.mat flag_frames
[FileName,PathName] = uigetfile('*.mat','Select the Mat-file containing the particles coordinates');

if  (FileName==0) 
%    'Please select the .Mat file to load the coordinates of particles'
   errordlg('Task cancelled','Error');
else 
    [pathstr, name, ext] = fileparts(FileName);
    if  (strcmp('.mat',ext)==0) 
        'Please select the .Mat file to load the coordinates of particles'
        errordlg('Please select the .Mat file to load the coordinates of particles','Error');

    else 
        c=struct2cell(load(FileName));
        particles=c{1,1};
        if size(particles,3)>1
            particle(:,:)=particles(:,:,1);
        else
            particle=particles;
        end
        Num_frames=size(particles,3);
        save(strcat(strcat(strcat(path_data,'temp'),joint),'Num_frames_view.mat'),'Num_frames');
        set(handles.uitable1,'data',particle);
        set(handles.text2,'String',sprintf('Particles for the frame Number %g',1));
        
        save(strcat(path_data,'particles_view.mat'),'particles');
        flag_frames=1;
        save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
    end
end
guidata(hObject, handles);


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
% save flag_frames.mat flag_frames
For_3D_visual

guidata(hObject, handles);

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames')
% save flag_frames.mat flag_frames
for_Qmap
guidata(hObject, handles);

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
% save flag_frames.mat flag_frames
[FileName,PathName] = uigetfile('*.mat','Select the Mat-file containing the hologram or the video of holograms');

if  (FileName==0) 
%    'Please select the .Mat file to load the hologram'
   errordlg('Task cancelled','Error');
else 
    [pathstr, name, ext] = fileparts(FileName);
    if  (strcmp('.mat',ext)==0) 
        'Please select the .Mat file to load the hologram'
        errordlg('Please select the .Mat file to load the hologram or the video of holograms','Error');

    else 
        IA_name=FileName;
        IA_path=PathName;
        
        save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_name.mat'),'IA_name');

%         save IA_name.mat IA_name
        save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_path.mat'),'IA_path');

%         save IA_path.mat IA_path

        Inverse_approach_info
    end
end
guidata(hObject, handles);

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
load path_data.mat
load joint_path.mat
Num_frames=struct2cell(load(strcat(strcat(strcat(path_data,'temp'),joint),'Num_frames_view.mat')));
Num_frames=Num_frames{1,1};
% load Num_frames.mat


flag_frames=struct2cell(load(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat')));
flag_frames=flag_frames{1,1};
% load flag_frames.mat


if (flag_frames < Num_frames)
  flag_frames=flag_frames+1;
  
  save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');

  particle=struct2cell(load(strcat(path_data,'particles_view.mat')));
  particle=particle{1,1};
  particle=particle(:,:,flag_frames);
  set(handles.uitable1,'data',particle);
  set(handles.text2,'String',sprintf('Particles for the frame Number %g',flag_frames));
  guidata(hObject, handles);
else
    errordlg('Exceeding the number of frames','Error');
end



function pushbutton6_Callback(hObject, eventdata, handles)
load path_data.mat
load joint_path.mat
flag_frames=0;
save(strcat(strcat(strcat(path_data,'temp'),joint),'flag_frames.mat'),'flag_frames');
save flag_frames.mat flag_frames
%% ask for the particles
[FileName,PathName] = uigetfile('*.mat','Select the Mat-file containing the particle coordinates');

if  (FileName==0) 
%    'Please select the .Mat file to load the hologram'
   errordlg('Task cancelled','Error');
else 
    [pathstr, name, ext] = fileparts(FileName);
    if  (strcmp('.mat',ext)==0) 
        'Please select the .Mat file to load the coordinates'
        errordlg('Select the Mat-file containing the particle coordinates','Error');

    else 
        IA_name_ref=FileName;
        IA_path_ref=PathName;
        
        particSET=struct2cell(load(strcat(IA_path_ref,IA_name_ref)));
        particSET=cell2mat(particSET);
        S_partic=size(particSET,3);
    %% now ask for the hologram
        
         [FileName,PathName] = uigetfile('*.mat','Select the Mat-file containing your hologram(s)');

        if  (FileName==0) 
        %    'Please select the .Mat file to load the hologram'
           errordlg('Task cancelled','Error');
        else 
            [pathstr, name, ext] = fileparts(FileName);
            if  (strcmp('.mat',ext)==0) 
                'Please select the .Mat file to load the coordinates'
                errordlg('Select the Mat-file containing your hologram(s)','Error');

            else 
                IA_name=FileName;
                IA_path=PathName;


                hol=struct2cell(load(strcat(IA_path,IA_name)));
                hol=cell2mat(hol);
                S_hol=size(hol,3);
                if S_hol~=S_partic
    errordlg(sprintf('The number of holograms does not match the number of coordinate sets you have provided.\n please make sure to do so.'),'Error');pause(5);
                    return;
                end
                save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_name_ref.mat'),'IA_name_ref');
                save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_path_ref.mat'),'IA_path_ref');

                save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_name.mat'),'IA_name');
                save(strcat(strcat(strcat(path_data,'temp'),joint),'IA_path.mat'),'IA_path');

                
               Refinement_info
            end
        end
    end
end
guidata(hObject, handles);